#pragma once

#include <stdio.h>

#include "accessor.h"

/* A host filesystem file accessor, providing flexpages corresponding to file
   regions. */

class HostFileAccessor : public Accessor
{
protected:
    const char *_path;
    FILE *_fp;

    /* Data transfer helper methods. */

    virtual void fill_populated(Flexpage *flexpage);

    virtual void flush_populated(Flexpage *flexpage);

public:
    explicit HostFileAccessor(const char *path, fileid_t fileid);

    virtual void close();

    virtual void open();
};

// vim: tabstop=4 expandtab shiftwidth=4
